/*****************************************************************
 * FILE: alignalign.h
 *****************************************************************
 * Copyright 2005 by Dean Starrett, Travis Wheeler
 * University of Arizona
 * Department of Computer Science
 * Tucson, AZ  85721
 *****************************************************************
 * Terms of use:
 * This software may be used for non-commercial purposes.
 * Other use, redistribution, or modification may be done only 
 * with the author's prior approval. (contact twheeler@cs.arizona.edu)
 *
 * Released: 17 May 2007
 * Version:  1.0.0
 * 
 ****************************************************************/

#ifndef   AA_H
#define   AA_H

#include <stdio.h> /* fprintf */
#include "aa_globals.h"
#include "spcost.h"
#include "pessimistic_optimistic.h"
#include "mem.h"
#include "shape.h"
#include "bound.h"
#include "subs.h"

int RemoveNullColumns(char **M, int rows, int cols);
void FindFirstAndLastChars ( char **M, int **firstChars, int **lastChars, int rows, int cols );

void aa_setCosts ( int ***cost, int alpha_size, char *alphabet, 
				int *alphaconv,	int gamma, int lambda, int gamma_terminal, int lambda_terminal);
void aa_setWeights ( int K, int **weights);		
void aa_freeWeights ();
void aa_setUnweighted();
		
int alignalign(	int space_optimized, char ***A, int K, int M, 
	char ***B, int L, int N, char ***alignment_ptr, unsigned char **script_ptr);

	
int alignalign_time  (char ***alignment_ptr);
int alignalign_space (char ***alignment_ptr);
aa_ushort *RecursiveDPArrayPathFinder(int a1, int a2, int b1, int b2,
		      aa_ushort *pred, aa_ushort *succ);
aa_ushort *BaseCase(int a1, int a2, int b1, int b2,
		     aa_ushort *pred, aa_ushort *succ);
void EvaluateForward(int a1, int a2, int b1, int b2, aa_ushort *pred);
void EvaluateReverse(int a1, int a2, int b1, int b2, aa_ushort *succ);
void ensureScriptLongEnough ();

int gaps (int a, int b, aa_ushort *s, int dir);

inline int GetGamma (int *first, int *last, int row, int col);
inline int GetLambda (int *first, int *last, int row, int col);
void flipFirstLastCharArrays() ;
#endif
