/*****************************************************************
 * FILE: insert.c
 *****************************************************************
 * Copyright 2005 by Dean Starrett, Travis Wheeler
 * University of Arizona
 * Department of Computer Science
 * Tucson, AZ  85721
 *****************************************************************
 * Terms of use:
 * This software may be used for non-commercial purposes.
 * Other use, redistribution, or modification may be done only 
 * with the author's prior approval. (contact twheeler@cs.arizona.edu)
 *
 * Released: 17 May 2007
 * Version:  1.0.0
 * 
 ****************************************************************/

#include <stdlib.h> /* NULL   */
#include <string.h> /* memcpy */
#include "shape.h"

/********************************************************************
 * Procedure: insert
 *******************************************************************/
inline void
insert (Shape *list, aa_ushort *s, int c, Shape *propagating) {
  static Shape *p;
  static Shape *shape;

  p = NEXT(list);
  shape = nodemalloc();
  /* set the shape representation */
  memcpy(S(shape), s, (aa_K+aa_L) * sizeof(unsigned short));
  C(shape) = c; /* set cost associated with new shape */
  /* insert new shape at front of list (arbitrary) */
  NEXT(shape) = p;
  NEXT(list) = shape;
  RECOVER(shape) = propagating; /* set recovery pointer to propagating shape */
  (C(propagating))++;     /* increment reference count for propagating shape */

  return;
}

/********************************************************************
 * Procedure: insert
 *******************************************************************/
inline void
insert_space (Shape *list, aa_ushort *s, int c) {
  static Shape *p;
  static Shape *shape;

  p = NEXT(list);
  shape = nodemalloc();
  /* set the shape representation */
  memcpy(S(shape), s, (aa_K+aa_L) * sizeof(unsigned short));
  C(shape) = c; /* set cost associated with new shape */
  /* insert new shape at front of list (arbitrary) */
  NEXT(shape) = p;
  NEXT(list) = shape;

  return;
}
