/*****************************************************************
 * FILE: mem.c
 *****************************************************************
 * Copyright 2005 by Dean Starrett, Travis Wheeler
 * University of Arizona
 * Department of Computer Science
 * Tucson, AZ  85721
 *****************************************************************
 * Terms of use:
 * This software may be used for non-commercial purposes.
 * Other use, redistribution, or modification may be done only 
 * with the author's prior approval. (contact twheeler@cs.arizona.edu)
 *
 * Released: 17 May 2007
 * Version:  1.0.0
 * 
 ****************************************************************/

#include <stdlib.h> /* NULL */
#include <stdio.h>  /* fprintf */
#include <errno.h>

/* malloc with error detection */
inline void *
aa_malloc(unsigned int size) {
	void *ptr = malloc((size_t) size);
	if (NULL == ptr) { 
		fprintf(stderr, "Out of memory, trying to malloc %d bytes.\n", size); 
		exit(1); 
	}
  	return ptr; 
}  

/* malloc with error detection */
inline void *
aa_realloc(void *ptr, unsigned int size) { 
  ptr = realloc(ptr, (size_t) size);
  if (NULL == ptr) { 
  		fprintf(stderr, "Out of memory, trying to realloc %d bytes.\n", size); 
  		exit(1); 
  }
  return ptr; 
} 

inline void
aa_free(void *ptr, int size) { free(ptr); }


